"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_bankfeeds.models.shared import (
    sourceaccount as shared_sourceaccount,
    sourceaccountbatchcreateresponse as shared_sourceaccountbatchcreateresponse,
    sourceaccountbatcherrorresponse as shared_sourceaccountbatcherrorresponse,
    sourceaccountv2 as shared_sourceaccountv2,
    sourceaccountv2batchcreateresponse as shared_sourceaccountv2batchcreateresponse,
)
from codat_bankfeeds.types import BaseModel
from codat_bankfeeds.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import pydantic
from typing import List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


CreateBatchSourceAccountRequestBodyTypedDict = TypeAliasType(
    "CreateBatchSourceAccountRequestBodyTypedDict",
    Union[
        List[shared_sourceaccountv2.SourceAccountV2TypedDict],
        List[shared_sourceaccount.SourceAccountTypedDict],
    ],
)


CreateBatchSourceAccountRequestBody = TypeAliasType(
    "CreateBatchSourceAccountRequestBody",
    Union[
        List[shared_sourceaccountv2.SourceAccountV2],
        List[shared_sourceaccount.SourceAccount],
    ],
)


class CreateBatchSourceAccountRequestTypedDict(TypedDict):
    company_id: str
    r"""Unique identifier for a company."""
    connection_id: str
    r"""Unique identifier for a connection."""
    request_body: NotRequired[CreateBatchSourceAccountRequestBodyTypedDict]


class CreateBatchSourceAccountRequest(BaseModel):
    company_id: Annotated[
        str,
        pydantic.Field(alias="companyId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Unique identifier for a company."""

    connection_id: Annotated[
        str,
        pydantic.Field(alias="connectionId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Unique identifier for a connection."""

    request_body: Annotated[
        Optional[CreateBatchSourceAccountRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


CreateBatchSourceAccount1TypedDict = TypeAliasType(
    "CreateBatchSourceAccount1TypedDict",
    Union[
        shared_sourceaccountv2batchcreateresponse.SourceAccountV2BatchCreateResponseTypedDict,
        shared_sourceaccountbatchcreateresponse.SourceAccountBatchCreateResponseTypedDict,
        shared_sourceaccountbatcherrorresponse.SourceAccountBatchErrorResponseTypedDict,
    ],
)


CreateBatchSourceAccount1 = TypeAliasType(
    "CreateBatchSourceAccount1",
    Union[
        shared_sourceaccountv2batchcreateresponse.SourceAccountV2BatchCreateResponse,
        shared_sourceaccountbatchcreateresponse.SourceAccountBatchCreateResponse,
        shared_sourceaccountbatcherrorresponse.SourceAccountBatchErrorResponse,
    ],
)


CreateBatchSourceAccountSourceAccountsResponseBodyTypedDict = List[
    CreateBatchSourceAccount1TypedDict
]
r"""Multi-Status"""


CreateBatchSourceAccountSourceAccountsResponseBody = List[CreateBatchSourceAccount1]
r"""Multi-Status"""


OneTypedDict = TypeAliasType(
    "OneTypedDict",
    Union[
        shared_sourceaccountv2batchcreateresponse.SourceAccountV2BatchCreateResponseTypedDict,
        shared_sourceaccountbatchcreateresponse.SourceAccountBatchCreateResponseTypedDict,
    ],
)


One = TypeAliasType(
    "One",
    Union[
        shared_sourceaccountv2batchcreateresponse.SourceAccountV2BatchCreateResponse,
        shared_sourceaccountbatchcreateresponse.SourceAccountBatchCreateResponse,
    ],
)


CreateBatchSourceAccountResponseBodyTypedDict = List[OneTypedDict]
r"""Success"""


CreateBatchSourceAccountResponseBody = List[One]
r"""Success"""


CreateBatchSourceAccountResponseTypedDict = TypeAliasType(
    "CreateBatchSourceAccountResponseTypedDict",
    Union[
        CreateBatchSourceAccountResponseBodyTypedDict,
        CreateBatchSourceAccountSourceAccountsResponseBodyTypedDict,
    ],
)


CreateBatchSourceAccountResponse = TypeAliasType(
    "CreateBatchSourceAccountResponse",
    Union[
        CreateBatchSourceAccountResponseBody,
        CreateBatchSourceAccountSourceAccountsResponseBody,
    ],
)
